--Global table for pills
_G.avalonPills = _G.avalonPills or {}
avalonPills_mod_path = ModPath

--Localization
Hooks:Add("LocalizationManagerPostInit", "avalon_LocalizationManagerPostInit", function(loc)
	loc:load_localization_file(avalonPills_mod_path.."loc/EN.txt")
end)

if PlayerManager then --Checking for player manager
	Hooks:PostHook(PlayerManager,"init","playermanager_init_avalon",function(self)
		self.avalonRushdownActive = false

		self.avalonOrgDodgeDuration = 7
		self.avalonDodgeDuration = 7

		self.skill_1_Dodge = 45
		self.skill_3_Dodge = 75

		self.skill_2_Speed = .3
		self.skill_4_Speed = .05

		self.killShotWindow = 2
		self.killShotDelay = 3
		self.killShotActive = true --REMEMBER: Timer to make sure kill shot is not infinite
		self.cooldownKillShotDecrease = 3
		self.rushdownDurationKillShotIncrease = 1

		self.killShotCounter = 0
		self.killCounter = 0
		self.scapeGoatCounter = 0

		self.killShot_last = -69 --haaaaaaaaaa also

		self.lastTimeRushdownActive = -420 --haaaaaaaaaaaaaaaa
	end)

	
	function PlayerManager:hasAvalonPills() --Function for checking if has pills
		if managers.blackmarket:equipped_grenade() ~= "avalonPills" then
			return false
		end
		return true
	end
	function PlayerManager:useAvalonPills() --Function for well using it
		if self:hasAvalonPills() then
			local local_peer_id = managers.network:session() and managers.network:session():local_peer():id()

			if (not local_peer_id) or (not self:has_category_upgrade("player","avalonSkill_1")) then --Checking if has perk deck
				print("Pain")
				return
			else --Activating Pills
				print("Activating Rushdown")
				self.killCounter = 0 --Resetting Counters
				self.scapeGoatCounter = 0
				self.killShotCounter = 0

				self.avalonRushdownActive = true
				self.lastTimeRushdownActive = Application:time()

				--Refreshing stamina
				managers.player:player_unit():movement():add_stamina(managers.player:player_unit():movement():_max_stamina())
			end
		end
	end

	--Functawjndnaw
	Hooks:PostHook(PlayerManager, "spawned_player", "avalonPills_spawned_player", function(self)
		if self:hasAvalonPills() then
			--Handling pseudopills 
			local on_ability_activated_key = {}
			self:register_message("ability_activated", on_ability_activated_key, function(ability_name)
				if ability_name == "avalonPills" then
					if managers.player:hasAvalonPills() then
						managers.player:useAvalonPills()
						return
					end
				end
			end)
		end
	end)

	Hooks:PostHook(PlayerManager,"update","playermanager_update_avalon",function(self, t, dt)
		local player = self:player_unit()

		--Checks if dodge duration is too long
		if self.avalonRushdownActive and Utils:IsInHeist() and Utils:IsInGameState() and not Utils:IsInCustody() then --Checks if kill shot is active and is in heist
			if (self.lastTimeRushdownActive + self.avalonDodgeDuration) < t then
				print("Deactivating Rushdown")
				player:sound():play(tweak_data.blackmarket.projectiles.chico_injector.sounds.cooldown) --Playing Sound to Alert Player

				self.avalonRushdownActive = false
				self.avalonDodgeDuration = self.avalonOrgDodgeDuration --Resetting Dodge Duration Back
			end
		end
		if not self.killShotActive then --Checks if kill shot is active
			if (self.killShot_last + self.killShotDelay) < t then
				print("Kill Shot is Active")
				self.killShotActive = true
			end
		end
	end)
	--On killed cop
	Hooks:PostHook(PlayerManager,"on_killshot","avalon_KilledCop",function(self, attacker_unit, attack_data)
		local currentTime = Application:time()
		local player = self:player_unit()

		if not self.avalonRushdownActive then
			managers.player:speed_up_grenade_cooldown(1)
		end

		self.killCounter = self.killCounter + 1

		if self:has_category_upgrade("player","avalonSkill_4") and self.avalonRushdownActive then
			if self.scapeGoatCounter < 3 then
				if self.killCounter >= 2 then
					self.killCounter = 0
					self.scapeGoatCounter = self.scapeGoatCounter + 1

					if not self:has_category_upgrade("player", "frenzy") then
						print("Healing")
						player:character_damage():set_health((player:character_damage():health_ratio()*player:character_damage():_max_health()) + (player:character_damage():_max_health() * .05))
					end
				end
			end
		end 
		if self:has_category_upgrade("player","avalonSkill_2") and self.killShotActive then
			if currentTime <= (self.killShot_last + self.killShotWindow) then --Checking if it's in the time window, for killshot 2 people
				-- haha fuck yeah man
				if not self.avalonRushdownActive then --Check if Rushdown is active
					managers.player:speed_up_grenade_cooldown(self.cooldownKillShotDecrease) --Decreases pills cooldown
				end
				self.killShotActive = false
			end
			if self.avalonRushdownActive then
				self.avalonDodgeDuration = self.rushdownDurationKillShotIncrease + self.avalonDodgeDuration --Increases dodge duration in rushdown
				print("Increasing Dodge")
			end
		end
		self.killShot_last = currentTime
	end)

	Hooks:PostHook(PlayerManager, "movement_speed_multiplier", "movementSpeedMultUpdate", function(self, speed_state, bonus_multiplier) --Speed Stuff for avalonSkill_2
	    if self:has_category_upgrade("player","avalonSkill_3") and self.avalonRushdownActive then 
		if not bonus_multiplier then
			bonus_multiplier = 1
		end
		local counter = bonus_multiplier + ((bonus_multiplier * .3)+1)

		if self:has_category_upgrade("player", "frenzy") then
			counter = counter + ((bonus_multiplier * self.skill_4_Speed * self.scapeGoatCounter)+1)
		end
	    	return counter
	    end
	end)

	-- this *should* make the dodge buff effect actually work without completely fucking up the way the base game calculates dodge chances.
	-- i might be wrong but here's hoping i'm not lol
	local orig_calc_dodge = orig_calc_dodge or PlayerManager.skill_dodge_chance
	function PlayerManager:skill_dodge_chance(...)
		local chance = 0
		local turboBonus = 0
		if self.avalonRushdownActive then --Checks if pills is active
			if self:has_category_upgrade("player","avalonSkill_3") then
				turboBonus = self.skill_3_Dodge/100 -- MAX DODGE YEAAAA if the player has deck maxed out
			elseif self:has_category_upgrade("player","avalonSkill_1") then
				turboBonus = self.skill_1_Dodge/100  --ehhh 45 dodge ok
			end
		end
		chance = chance + orig_calc_dodge(self,...) --dodge lol
		chance = chance + turboBonus
		return chance
	end
end